# pi-top's Alexa Voice Service integration

## General Information
In order to make use of this service, it is required to link an Amazon account with your pi-top account. Once this is done, it is possible to use this service by simply being logged into your pi-top account. This is easiest if used in pi-topOS, but is compatibile with Raspbian.

In order for this implementation to work, `pt-avs` in the `bin` directory is required to be installed in a location that is in your PATH environment variable. For simplicity, it is most easily placed into `/usr/bin` (with executable permissions).

## Dependencies
* `jq` for parsing JSON responses
* `mpg123` for playing
* `python-pt-pulse`, as this software implementation currently only supports pi-topPULSE hardware for recording

## pi-topOS
**This is all handled automatically. Dashboard icon. Setup on device. Re-logging in.**

## Raspbian
### Setup
In order to make use of this service, it is required to link an Amazon account with your pi-top account. This can be done by going to your [account page on the pi-top website](https://pi-top.com/account).

### Running
Included in `demo.sh` in the example directory is a working implementation. An explanation of how this code works is provided, but can be repurposed as required (e.g., it might be triggered by a button or web event).

The first part of the process is to log in with your pi-top credentials:
`pt-avs pt-access-token $MY_PT_USERNAME $MY_PT_PASSWORD`
The response will provide you with a pi-top user ID and access token. These can then be used to get an Alexa Voice Service access token:
`pt-avs avs-access-token -u "$PT_USER_ID" -t "$PT_ACCESS_TOKEN"`
Provided that this was successful, you are now able to upload your audio recording to Amazon's Alexa Voice Service:
`pt-avs upload -t "$AVS_ACCESS_TOKEN"`
When this is complete, you can play the Alexa response:
`pt-avs playback`